import { AddressMode, BlendFactor, BlendMode, BufferFrequencyHint, CompareFunction, CullMode, Format, PrimitiveTopology, StencilOp } from '@antv/g-device-api';
import type { TypedArray } from './utils/typedarray';
export declare const typedArrayCtorMap: {
    [key: string]: new (data: number[]) => TypedArray;
};
export declare const primitiveMap: {
    [key: string]: PrimitiveTopology;
};
export declare const sizeFormatMap: {
    [key: number]: Format;
};
export declare const hintMap: {
    [key: string]: BufferFrequencyHint;
};
export declare const wrapModeMap: {
    [key: string]: AddressMode;
};
export declare const depthFuncMap: {
    [key: string]: CompareFunction;
};
export declare const cullFaceMap: {
    [key: string]: CullMode;
};
export declare const blendEquationMap: {
    [key: string]: BlendMode;
};
export declare const blendFuncMap: {
    [key: string]: BlendFactor;
};
export declare const stencilOpMap: {
    [key: string]: StencilOp;
};
export declare const stencilFuncMap: {
    [key: string]: CompareFunction;
};
