// src/regl/ReglRenderbuffer.ts
import { formatMap } from "./constants";
var ReglRenderbuffer = class {
  constructor(reGl, options) {
    const { width, height, format } = options;
    this.renderbuffer = reGl.renderbuffer({
      width,
      height,
      format: formatMap[format]
    });
  }
  get() {
    return this.renderbuffer;
  }
  destroy() {
    this.renderbuffer.destroy();
  }
  resize({ width, height }) {
    this.renderbuffer.resize(width, height);
  }
};
export {
  ReglRenderbuffer as default
};
