import type { Device, RenderTarget, Texture } from '@antv/g-device-api';
import type { IFramebuffer, IFramebufferInitializationOptions } from '@antv/l7-core';
/**
 * Contains 2 render targets: color and depth.
 */
export default class DeviceFramebuffer implements IFramebuffer {
    private device;
    private options;
    private colorRenderTarget;
    colorTexture: Texture;
    private depthRenderTarget;
    private depthTexture;
    private width;
    private height;
    constructor(device: Device, options: IFramebufferInitializationOptions);
    private createColorRenderTarget;
    private createDepthRenderTarget;
    get(): RenderTarget;
    destroy(): void;
    resize({ width, height }: {
        width: number;
        height: number;
    }): void;
}
