import type { Device, Texture } from '@antv/g-device-api';
import type { ITexture2D, ITexture2DInitializationOptions } from '@antv/l7-core';
export declare function isTexture2D(t: any): t is ITexture2D;
export default class DeviceTexture2D implements ITexture2D {
    private device;
    private options;
    private texture;
    private sampler;
    private width;
    private height;
    private isDestroy;
    constructor(device: Device, options: ITexture2DInitializationOptions);
    private createTexture;
    get(): Texture;
    update(props: any): void;
    bind(): void;
    resize({ width, height }: {
        width: number;
        height: number;
    }): void;
    getSize(): [number, number];
    destroy(): void;
}
